## fskit 1.0.3

=== Makefile ===

include ./buildconf.mk

all:
	$(MAKE) -C libfskit REPL=$(REPL)
	$(MAKE) -C fuse

install:
	$(MAKE) -C libfskit install
	$(MAKE) -C fuse install

test:
	$(MAKE) -C test 

fuse-demo:
	$(MAKE) -C demo 

uninstall:
	$(MAKE) -C libfskit uninstall
	$(MAKE) -C fuse uninstall

clean:
	$(MAKE) -C libfskit clean
	$(MAKE) -C test clean
	$(MAKE) -C fuse clean
	$(MAKE) -C demo clean

.PHONY: all install clean

=== demo/Makefile ===

include ../buildconf.mk

LIB   := $(PTHREAD_LIBS) $(FUSE_LIBS) -L../libfskit -lfskit -L../fuse -lfskit_fuse -lm
INC   := $(PTHREAD_CFLAGS) $(FUSE_CFLAGS) -I../include -I. -I..
C_SRCS:= $(wildcard *.c)
OBJ   := $(patsubst %.c,%.o,$(C_SRCS))
DEFS  := -D_REENTRANT -D_THREAD_SAFE -D__STDC_FORMAT_MACROS -D_FILE_OFFSET_BITS=64

FUSE_DEMO = fuse-demo

all:	$(FUSE_DEMO)

$(FUSE_DEMO): $(OBJ)
	$(CC) $(CCFLAGS) -o $@ $(OBJ) $(LIB)

%.o : %.c
	$(CC) $(CCFLAGS) -o $@ $(INC) -c $< $(DEFS)

.PHONY: clean
clean:
	rm -f $(OBJ) $(FUSE_DEMO)

=== fuse/Makefile ===

include ../buildconf.mk

C_SRCS:= $(wildcard *.c)
OBJ   := $(patsubst %.c,$(BUILD_LIBFSKIT_FUSE)/%.o,$(C_SRCS))
LIBS  := -lpthread -lfuse
DEFS  := $(DEFS) -D_FILE_OFFSET_BITS=64

PC_FILE		:= $(BUILD_PKGCONFIG)/fskit_fuse.pc
PC_FILE_INSTALL := $(PKGCONFIGDIR)/fskit_fuse.pc
PC_FILE_IN  := fskit_fuse.pc.in

LIBFSKIT_FUSE := libfskit_fuse.so
LIBFSKIT_FUSE_SO := libfskit_fuse.so.$(LIBFSKIT_FUSE_MAJOR)
LIBFSKIT_FUSE_LIB := libfskit_fuse.so.$(LIBFSKIT_FUSE_MAJOR).$(LIBFSKIT_FUSE_MINOR).$(LIBFSKIT_FUSE_PATCH)

LIBFSKIT_FUSE_TARGET := $(patsubst %,$(BUILD_LIBFSKIT_FUSE)/%,$(LIBFSKIT_FUSE))
LIBFSKIT_FUSE_SO_TARGET := $(patsubst %,$(BUILD_LIBFSKIT_FUSE)/%,$(LIBFSKIT_FUSE_SO))
LIBFSKIT_FUSE_LIB_TARGET := $(patsubst %,$(BUILD_LIBFSKIT_FUSE)/%,$(LIBFSKIT_FUSE_LIB))

LIBFSKIT_FUSE_INSTALL_TARGET := $(patsubst $(BUILD_LIBFSKIT_FUSE)/%,$(INSTALL_LIBFSKIT_FUSE)/%,$(LIBFSKIT_FUSE_TARGET))
LIBFSKIT_FUSE_SO_INSTALL_TARGET := $(patsubst $(BUILD_LIBFSKIT_FUSE)/%,$(INSTALL_LIBFSKIT_FUSE)/%,$(LIBFSKIT_FUSE_SO_TARGET))
LIBFSKIT_FUSE_LIB_INSTALL_TARGET := $(patsubst $(BUILD_LIBFSKIT_FUSE)/%,$(INSTALL_LIBFSKIT_FUSE)/%,$(LIBFSKIT_FUSE_LIB_TARGET))

LIBFSKIT_FUSE_INSTALL: $(patsubst $(BUILD_LIBFSKIT_FUSE)/%,$(INSTALL_LIBFSKIT_FUSE)/%,$(LIBFSKIT_FUSE_TARGET) $(LIBFSKIT_FUSE_SO_TARGET) $(LIBFSKIT_FUSE_LIB_TARGET))

HEADERS := $(wildcard *.h)
BUILD_HEADERS := $(patsubst %.h,$(BUILD_LIBFSKIT_FUSE_HEADERS)/%.h,$(HEADERS))
INSTALL_HEADERS := $(patsubst $(BUILD_LIBFSKIT_FUSE_HEADERS)/%.h,$(INSTALL_LIBFSKIT_FUSE_HEADERS)/%.h,$(BUILD_HEADERS))

all: $(LIBFSKIT_FUSE_TARGET) $(LIBFSKIT_FUSE_SO_TARGET) $(LIBFSKIT_FUSE_LIB_TARGET) $(BUILD_HEADERS) $(PC_FILE)

$(PC_FILE):	$(PC_FILE_IN)
	@mkdir -p "$(shell dirname "$@")"
	@cat "$<" | \
		sed -e 's~@PREFIX@~$(PREFIX)~g;' | \
		sed -e 's~@INCLUDEDIR@~$(INCLUDEDIR)~g;' | \
		sed -e 's~@VERSION@~$(VERSION)~g; ' | \
		sed -e 's~@LIBS@~$(LIBS)~g; ' | \
		sed -e 's~@LIBDIR@~$(LIBDIR)~g; ' | \
	   sed -e 's~@VERSION_MAJOR@~$(LIBFSKIT_FUSE_MAJOR)~g; ' | \
	   sed -e 's~@VERSION_MINOR@~$(LIBFSKIT_FUSE_MINOR)~g; ' | \
	   sed -e 's~@VERSION_PATCH@~$(LIBFSKIT_FUSE_PATCH)~g; '	> "$@"

$(LIBFSKIT_FUSE_LIB_TARGET): $(OBJ)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CCFLAGS) -shared -Wl,-soname,$(LIBFSKIT_FUSE_SO) -o $(LIBFSKIT_FUSE_LIB_TARGET) $(OBJ) $(LIBINC) $(LIBS)

$(LIBFSKIT_FUSE_SO_TARGET): $(LIBFSKIT_FUSE_LIB_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	@ln -sf "$(shell basename "$<")" "$@"

$(LIBFSKIT_FUSE_TARGET): $(LIBFSKIT_FUSE_SO_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	@ln -sf "$(shell basename "$<")" "$@"

$(BUILD_LIBFSKIT_FUSE_HEADERS)/%.h: %.h
	@mkdir -p "$(shell dirname "$@")"
	@cp -a "$<" "$@"

$(BUILD_LIBFSKIT_FUSE)/%.o : %.c $(BUILD_HEADERS)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CCFLAGS) -o "$@" $(INC) -c "$<" $(DEFS)


install: $(LIBFSKIT_FUSE_INSTALL_TARGET) $(LIBFSKIT_FUSE_SO_INSTALL_TARGET) $(LIBFSKIT_FUSE_LIB_INSTALL_TARGET) $(PC_FILE_INSTALL) $(INSTALL_HEADERS)

$(LIBFSKIT_FUSE_INSTALL_TARGET): $(LIBFSKIT_FUSE_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(LIBFSKIT_FUSE_SO_INSTALL_TARGET): $(LIBFSKIT_FUSE_SO_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(LIBFSKIT_FUSE_LIB_INSTALL_TARGET): $(LIBFSKIT_FUSE_LIB_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(PC_FILE_INSTALL): $(PC_FILE)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(INSTALL_LIBFSKIT_FUSE_HEADERS)/%.h: $(BUILD_LIBFSKIT_FUSE_HEADERS)/%.h
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

.PHONY: clean
clean:
	rm -f $(OBJ) $(LIBFSKIT_FUSE_TARGET) $(LIBFSKIT_FUSE_SO_TARGET) $(LIBFSKIT_FUSE_LIB_TARGET) $(BUILD_HEADERS) $(PC_FILE)

.PHONY: uninstall
uninstall:
	rm -f $(LIBFSKIT_FUSE_INSTALL_TARGET) $(LIBFSKIT_FUSE_SO_INSTALL_TARGET) $(LIBFSKIT_FUSE_LIB_INSTALL_TARGET) $(INSTALL_HEADERS) $(PC_FILE_INSTALL)

print-%: ; @echo $*=$($*)

=== libfskit/Makefile ===

include ../buildconf.mk

C_SRCS:= $(wildcard *.c)
OBJ   := $(patsubst %.c,$(BUILD_LIBFSKIT)/%.o,$(C_SRCS))
LIBS  := -lpthread

PC_FILE		:= $(BUILD_PKGCONFIG)/fskit.pc
PC_FILE_INSTALL := $(PKGCONFIGDIR)/fskit.pc
PC_FILE_IN  := fskit.pc.in

LIBFSKIT := libfskit.so
LIBFSKIT_SO := libfskit.so.$(LIBFSKIT_MAJOR)
LIBFSKIT_LIB := libfskit.so.$(LIBFSKIT_MAJOR).$(LIBFSKIT_MINOR).$(LIBFSKIT_PATCH)

LIBFSKIT_TARGET := $(patsubst %,$(BUILD_LIBFSKIT)/%,$(LIBFSKIT))
LIBFSKIT_SO_TARGET := $(patsubst %,$(BUILD_LIBFSKIT)/%,$(LIBFSKIT_SO))
LIBFSKIT_LIB_TARGET := $(patsubst %,$(BUILD_LIBFSKIT)/%,$(LIBFSKIT_LIB))

LIBFSKIT_INSTALL_TARGET := $(patsubst $(BUILD_LIBFSKIT)/%,$(INSTALL_LIBFSKIT)/%,$(LIBFSKIT_TARGET))
LIBFSKIT_SO_INSTALL_TARGET := $(patsubst $(BUILD_LIBFSKIT)/%,$(INSTALL_LIBFSKIT)/%,$(LIBFSKIT_SO_TARGET))
LIBFSKIT_LIB_INSTALL_TARGET := $(patsubst $(BUILD_LIBFSKIT)/%,$(INSTALL_LIBFSKIT)/%,$(LIBFSKIT_LIB_TARGET))

# LIBFSKIT_INSTALL: $(patsubst $(BUILD_LIBFSKIT)/%,$(INSTALL_LIBFSKIT)/%,$(LIBFSKIT_TARGET) $(LIBFSKIT_SO_TARGET) $(LIBFSKIT_LIB_TARGET))

HEADERS := $(wildcard ../include/fskit/*.h)
PRIVATE_HEADERS := $(wildcard ../include/fskit_private/*.h)

BUILD_HEADERS := $(patsubst ../include/fskit/%.h,$(BUILD_LIBFSKIT_HEADERS)/%.h,$(HEADERS))
BUILD_PRIVATE_HEADERS := $(patsubst ../include/fskit_private/%.h,$(BUILD_PRIVATE_INCLUDEDIR)/%.h,$(PRIVATE_HEADERS))

INSTALL_HEADERS := $(patsubst $(BUILD_LIBFSKIT_HEADERS)/%.h,$(INSTALL_LIBFSKIT_HEADERS)/%.h,$(BUILD_HEADERS))

all: $(LIBFSKIT_TARGET) $(LIBFSKIT_SO_TARGET) $(LIBFSKIT_LIB_TARGET) $(BUILD_HEADERS) $(BUILD_PRIVATE_HEADERS) $(PC_FILE)

$(PC_FILE):	$(PC_FILE_IN)
	@mkdir -p "$(shell dirname "$@")"
	@cat "$<" | \
		sed -e 's~@PREFIX@~$(PREFIX)~g;' \
			 -e 's~@INCLUDEDIR@~$(INCLUDEDIR)~g;' \
			 -e 's~@VERSION@~$(VERSION)~g; ' \
			 -e 's~@LIBS@~$(LIBS)~g; ' \
			 -e 's~@LIBDIR@~$(LIBDIR)~g; ' \
			 -e 's~@VERSION_MAJOR@~$(LIBFSKIT_MAJOR)~g; ' \
			 -e 's~@VERSION_MINOR@~$(LIBFSKIT_MINOR)~g; ' \
			 -e 's~@VERSION_PATCH@~$(LIBFSKIT_PATCH)~g; '	> "$@"

$(LIBFSKIT_LIB_TARGET): $(OBJ)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CCFLAGS) -D_GNU_SOURCE -shared -Wl,-soname,$(LIBFSKIT_SO) -o $(LIBFSKIT_LIB_TARGET) $(OBJ) $(LIBINC) $(LIBS)

$(LIBFSKIT_SO_TARGET): $(LIBFSKIT_LIB_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	@ln -sf "$(shell basename "$<")" "$@"

$(LIBFSKIT_TARGET): $(LIBFSKIT_SO_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	@ln -sf "$(shell basename "$<")" "$@"

$(BUILD_PRIVATE_INCLUDEDIR)/%.h: ../include/fskit_private/%.h
	@mkdir -p "$(shell dirname "$@")"
	@cp -a "$<" "$@"

$(BUILD_LIBFSKIT_HEADERS)/%.h: ../include/fskit/%.h
	@mkdir -p "$(shell dirname "$@")"
	@cp -a "$<" "$@"

$(BUILD_LIBFSKIT)/%.o : %.c $(BUILD_HEADERS) $(BUILD_PRIVATE_HEADERS)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CCFLAGS) -D_GNU_SOURCE -o "$@" $(INC) -c "$<" $(DEFS)

$(BUILD_LIBFSKIT)/%.o : %.cpp $(BUILD_HEADERS) $(BUILD_PRIVATE_HEADERS)
	@mkdir -p "$(shell dirname "$@")"
	$(CC) $(CCFLAGS) -D_GNU_SOURCE -o "$@" $(INC) -c "$<" $(DEFS)

libs-install: $(LIBFSKIT_INSTALL_TARGET) $(LIBFSKIT_SO_INSTALL_TARGET) $(LIBFSKIT_LIB_INSTALL_TARGET)

headers-install: $(PC_FILE_INSTALL) $(INSTALL_HEADERS)

install: libs-install headers-install

$(LIBFSKIT_INSTALL_TARGET): $(LIBFSKIT_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(LIBFSKIT_SO_INSTALL_TARGET): $(LIBFSKIT_SO_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(LIBFSKIT_LIB_INSTALL_TARGET): $(LIBFSKIT_LIB_TARGET)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(PC_FILE_INSTALL): $(PC_FILE)
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

$(INSTALL_LIBFSKIT_HEADERS)/%.h: $(BUILD_LIBFSKIT_HEADERS)/%.h
	@mkdir -p "$(shell dirname "$@")"
	cp -a "$<" "$@"

.PHONY: clean
clean:
	rm -f $(OBJ) "$(LIBFSKIT_TARGET)" "$(LIBFSKIT_SO_TARGET)" "$(LIBFSKIT_LIB_TARGET)" $(BUILD_HEADERS) $(BUILD_PRIVATE_HEADERS) "$(PC_FILE)"

.PHONY: uninstall
uninstall:
	rm -f "$(LIBFSKIT_INSTALL_TARGET)" "$(LIBFSKIT_SO_INSTALL_TARGET)" "$(LIBFSKIT_LIB_INSTALL_TARGET)" $(INSTALL_HEADERS) "$(PC_FILE_INSTALL)"

print-%: ; @echo $*=$($*)

=== test/Makefile ===

include ../buildconf.mk

LIB   := $(PTHREAD_LIBS) -L../libfskit -lfskit
INC   := $(PTHREAD_CFLAGS) -I../include -I.
C_SRCS:= $(wildcard *.c)
CXSRCS:= $(wildcard *.cpp)
OBJ   := $(patsubst %.c,%.o,$(C_SRCS)) $(patsubst %.cpp,%.o,$(CXSRCS))
DEFS  := -D_REENTRANT -D_THREAD_SAFE -D__STDC_FORMAT_MACROS -D_FILE_OFFSET_BITS=64

COMMON := common.cpp
COMMON_O := common.o

TESTS := $(patsubst test-%.o,test-%,$(OBJ))

all: $(TESTS)

test-% : test-%.o $(COMMON_O)
	$(CXX) $(CFLAGS) -o $@ $(COMMON_O) $< $(LIB)

%.o : %.c
	$(CXX) $(CFLAGS) -o $@ $(INC) -c $< $(DEFS)

%.o : %.cpp
	$(CXX) $(CFLAGS) -o $@ $(INC) -c $< $(DEFS)

.PHONY: clean
clean:
	rm -f $(OBJ) $(TESTS)

=== debian/changelog ===
fskit (1.0.3-1+genuen6u1) unstable; urgency=medium

  * New upstream version 1.0.3
  * Replace the <attr/xattr.h> header file with <sys/attr.h>
  * Add missing <attr/attributes.h> header file
  * Add the GNU_SOURCE macro in order to enable GNU extensions

 -- Aitor <aitor@genuen.org>  Sat, 20 Dec 2025 20:06:05 +0100

fskit (1.0.2-1+genuen6u1) unstable; urgency=medium

  * Build for excalibur

 -- Aitor <aitor@genuen.org>  Sat, 20 Dec 2025 19:31:18 +0100

fskit (1.0.2-1) unstable; urgency=low

  * Changed the source format to quilt.
  * Added some dependencies in debian/control.

 -- Aitor <aitor@genuen.org>  Sun, 12 Jun 2016 11:34:42 -0400

fskit (1.0.2) unstable; urgency=low

  * Updated packaging

 -- Zack Williams, University of Arizona <zdw@cs.arizona.edu>  Sun, 20 Mar 2016 21:50:56 -0700

fskit (1.0.1+142-dpkg0) dpkg; urgency=low

  * Generic dpkg packaging template

 -- Enrico Weigelt, metux IT consult <weigelt@metux.de>  Fri, 02 Jan 2015 16:19:13 +0100

=== debian/control ===
Source: fskit
Section: admin
Priority: optional
Maintainer: Aitor <aitor@genuen.org>
Uploaders: Jude Nelson <judecn@devuan.org>
Standards-Version: 3.9.6
Homepage: http://genuen.org
Origin: Genuen
Vcs-Git: git@git.devuan.org:pkgs-utopia-substitution/fskit.git
Vcs-Browser: https://git.devuan.org/pkgs-utopia-substitution/fskit.git
X-Python-Version: >= 2.7
XS-Testsuite: autopkgtest
Build-Depends: debhelper (>= 9),
               build-essential,
               pkg-config,
               libattr1-dev,
               libfuse-dev

Package: libfskit
Architecture: linux-any
Section: libs
Pre-Depends: ${misc:PreDepends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libattr1,
         libfskit-fuse (= ${binary:Version})
Description: A SDK for creating synthetic filesystems (runtime headers).
 It provides generic code and data structures for managing filesystem
 inodes, handles, permissions, reference counting, concurrency, and so on,
 so developers can focus on filesystem-specific features. With fskit,
 a fully-featured multithreaded filesystem can be written in just over
 200 lines of code.
 .
 Project goals:
  * Stable, extensible thread-safe API.
  * Minimal runtime dependencies.
  * Multi-threaded architecture.
  * Portable architecture.
  * C linkage.

Package: libfskit-dev
Architecture: linux-any
Section: devel
Pre-Depends: ${misc:PreDepends}
Depends: ${misc:Depends},
         build-essential,
         libattr1-dev,
         libfskit (= ${binary:Version})
Description: fskit headers for development.
 It provides generic code and data structures for managing filesystem
 inodes, handles, permissions, reference counting, concurrency, and so on,
 so developers can focus on filesystem-specific features. With fskit,
 a fully-featured multithreaded filesystem can be written in just over
 200 lines of code.
 .
 Project goals:
  * Stable, extensible thread-safe API.
  * Minimal runtime dependencies.
  * Multi-threaded architecture.
  * Portable architecture.
  * C linkage.

Package: libfskit-fuse
Architecture: linux-any
Section: libs
Pre-Depends: ${misc:PreDepends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libfuse2
Description: A helper library that wraps fskit into FUSE bindings (runtime) - FUSE backend.
 It provides generic code and data structures for managing filesystem
 inodes, handles, permissions, reference counting, concurrency, and so on,
 so developers can focus on filesystem-specific features. With fskit,
 a fully-featured multithreaded filesystem can be written in just over
 200 lines of code.
 .
 Project goals:
  * Stable, extensible thread-safe API.
  * Minimal runtime dependencies.
  * Multi-threaded architecture.
  * Portable architecture.
  * C linkage.

Package: libfskit-fuse-dev
Architecture: linux-any
Section: devel
Pre-Depends: ${misc:PreDepends}
Depends: ${misc:Depends},
         build-essential,
         libfuse-dev,
         libfskit-fuse (= ${binary:Version})
Description: fskit-fuse headers for development - FUSE backend.
 It provides generic code and data structures for managing filesystem
 inodes, handles, permissions, reference counting, concurrency, and so on,
 so developers can focus on filesystem-specific features. With fskit,
 a fully-featured multithreaded filesystem can be written in just over
 200 lines of code.
 .
 Project goals:
  * Stable, extensible thread-safe API.
  * Minimal runtime dependencies.
  * Multi-threaded architecture.
  * Portable architecture.
  * C linkage.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1


%:
	dh ${@}
